import { defineStore } from 'pinia'

export const useAuthStore = defineStore('auth', {
  state: () => ({
    loggedIn: false,
    user: null,
    registerOpen: false,
    loginOpen: false
  }),
  actions: {
    login (loggedIn) {
      this.loggedIn = loggedIn
    },
    setUser (user) {
      this.user = user
      if (user && window.drift && window.drift.identify) {
        window.drift.identify(user._id, {
          email: user.email,
          firstName: user.firstName
        })
      }
      if (!user && window.drift && window.drift.reset) {
        window.drift.reset()
      }
    },
    updateProfile (profile) {
      this.user = Object.assign({}, this.user, profile)
    },
    openRegister (open) {
      this.registerOpen = open
    },
    openLogin (open) {
      this.loginOpen = open
    }
  }
})
